
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Domain.h"
#include "ArgsDomainSave.h"
#include "ArgsDomainRestore.h"
#include "ArgsDomainGetXMLDesc.h"
#include "ArgsDomainMigrate.h"

#include <iostream>
#include <sstream>
#include <string.h>

using namespace qmf::com::redhat::libvirt;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Domain::packageName  = string ("com.redhat.libvirt");
string  Domain::className    = string ("domain");
uint8_t Domain::md5Sum[MD5_LEN]   =
    {0x50,0xe4,0x97,0x45,0xb3,0x6b,0xc3,0x68,0x42,0x94,0x8e,0x94,0x71,0xfe,0x1,0xea};

Domain::Domain (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent, const std::string& _uuid, const std::string& _name) :
    ManagementObject(_core),uuid(_uuid),name(_name)
{
    node = _parent->GetManagementObject ()->getObjectId ();
    id = 0;
    state = "";
    numVcpus = 0;
    active = "";
    maximumMemory = 0;
    memory = 0;
    cpuTime = 0;



}

Domain::~Domain ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Domain::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Domain::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (3); // Inst Element Count
    buf.putShort       (11); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "uuid";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Domain UUID";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Domain name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "id";
    ft[TYPE] = TYPE_S64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hypervisor Domain id, -1 if not running.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "node";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Node of this VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "state";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Domain state.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "numVcpus";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of virtual CPUs.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "active";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "true/false domain active.";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "maximumMemory";
    ft[TYPE] = TYPE_U64;
    ft[DESC] = "Maximum memory allowed in KB.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memory";
    ft[TYPE] = TYPE_U64;
    ft[DESC] = "Memory used in KB.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpuTime";
    ft[TYPE] = TYPE_U64;
    ft[DESC] = "CPU time used in nanoseconds.";
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "create";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Start stopped VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "destroy";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Stop this VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "undefine";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Undefine the domain";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "suspend";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Suspend this VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "resume";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Resume suspended VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "save";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Save this VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "filename";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Name of file to save VM image in";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "restore";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Restore saved VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "filename";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Name of file to restore from";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "shutdown";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Shutdown a VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "reboot";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Reboot VM";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "getXMLDesc";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Return an XML description of the domain.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "description";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    ft[DESC] = "XML description of the domain.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "migrate";
    ft[ARGCOUNT] = 5;
    ft[DESC] = "Migrate this VM to another host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "destinationUri";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Destination host connection uri.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "flags";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    ft[DESC] = "Flags for migration, see documentation for details.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "newDomainName";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "New domain name on new host if applicable.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "uri";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Destination hostname/URI as seen from host.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "bandwidth";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    ft[DESC] = "Maximum bandwidth to consume in Mbps.";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




uint32_t Domain::writePropertiesSize() const
{
    uint32_t size = writeTimestampsSize();

    size += (1 + uuid.length());  // uuid
    size += (1 + name.length());  // name
    size += 8;  // id
    size += 16;  // node
    size += (1 + state.length());  // state
    size += 4;  // numVcpus
    size += (1 + active.length());  // active

    return size;
}

void Domain::readProperties (const std::string& _sBuf)
{
    char *_tmpBuf = new char[_sBuf.length()];
    memcpy(_tmpBuf, _sBuf.data(), _sBuf.length());
    ::qpid::management::Buffer buf(_tmpBuf, _sBuf.length());
    Mutex::ScopedLock mutex(accessLock);

    {
        std::string _tbuf;
        buf.getRawData(_tbuf, writeTimestampsSize());
        readTimestamps(_tbuf);
    }


    buf.getShortString(uuid);
    buf.getShortString(name);
    id = buf.getInt64();
    {std::string _s; buf.getRawData(_s, node.encodedSize()); node.decode(_s);};
    buf.getShortString(state);
    numVcpus = buf.getLong();
    buf.getShortString(active);


    delete [] _tmpBuf;
}

void Domain::writeProperties (std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    {
        std::string _tbuf;
        writeTimestamps(_tbuf);
        buf.putRawData(_tbuf);
    }



    buf.putShortString(uuid);
    buf.putShortString(name);
    buf.putInt64(id);
    {std::string _s; node.encode(_s); buf.putRawData(_s);};
    buf.putShortString(state);
    buf.putLong(numVcpus);
    buf.putShortString(active);


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Domain::writeStatistics (std::string& _sBuf, bool skipHeaders)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders) {
        std::string _tbuf;
        writeTimestamps (_tbuf);
        buf.putRawData(_tbuf);
    }

    buf.putLongLong(maximumMemory);
    buf.putLongLong(memory);
    buf.putLongLong(cpuTime);


    // Maintenance of hi-lo statistics



    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Domain::doMethod (string& methodName, const string& inStr, string& outStr)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;

    bool _matched = false;

    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer outBuf(_msgChars, _bufSize);


    char *_tmpBuf = new char[inStr.length()];
    memcpy(_tmpBuf, inStr.data(), inStr.length());
    ::qpid::management::Buffer inBuf(_tmpBuf, inStr.length());

    if (methodName == "create") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_CREATE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "destroy") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "undefine") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_UNDEFINE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "suspend") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SUSPEND, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "resume") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_RESUME, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "save") {
        _matched = true;
        ArgsDomainSave ioArgs;
        inBuf.getShortString(ioArgs.i_filename);
        status = coreObject->ManagementMethod (METHOD_SAVE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "restore") {
        _matched = true;
        ArgsDomainRestore ioArgs;
        inBuf.getShortString(ioArgs.i_filename);
        status = coreObject->ManagementMethod (METHOD_RESTORE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "shutdown") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SHUTDOWN, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "reboot") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REBOOT, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "getXMLDesc") {
        _matched = true;
        ArgsDomainGetXMLDesc ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_description);
    }

    if (methodName == "migrate") {
        _matched = true;
        ArgsDomainMigrate ioArgs;
        inBuf.getShortString(ioArgs.i_destinationUri);
        ioArgs.i_flags = inBuf.getLong();
        inBuf.getShortString(ioArgs.i_newDomainName);
        inBuf.getShortString(ioArgs.i_uri);
        ioArgs.i_bandwidth = inBuf.getLong();
        status = coreObject->ManagementMethod (METHOD_MIGRATE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    delete [] _tmpBuf;


    if (!_matched) {
        outBuf.putLong(status);
        outBuf.putShortString(Manageable::StatusText(status, text));
    }

    uint32_t _bufLen = outBuf.getPosition();
    outBuf.reset();

    outBuf.getRawData(outStr, _bufLen);
}

std::string Domain::getKey() const
{
    std::stringstream key;

    key << uuid << ",";
    key << name;
    return key.str();
}



void Domain::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["uuid"] = ::qpid::types::Variant(uuid);
    _map["name"] = ::qpid::types::Variant(name);
    _map["id"] = ::qpid::types::Variant(id);
    _map["node"] = ::qpid::types::Variant(node);
    _map["state"] = ::qpid::types::Variant(state);
    _map["numVcpus"] = ::qpid::types::Variant(numVcpus);
    _map["active"] = ::qpid::types::Variant(active);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["maximumMemory"] = ::qpid::types::Variant(maximumMemory);
    _map["memory"] = ::qpid::types::Variant(memory);
    _map["cpuTime"] = ::qpid::types::Variant(cpuTime);


    // Maintenance of hi-lo statistics


    }
}

void Domain::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("uuid")) != _map.end()) {
        uuid = (_i->second).getString();
    }
    if ((_i = _map.find("name")) != _map.end()) {
        name = (_i->second).getString();
    }
    if ((_i = _map.find("id")) != _map.end()) {
        id = _i->second;
    }
    if ((_i = _map.find("node")) != _map.end()) {
        node = _i->second;
    }
    if ((_i = _map.find("state")) != _map.end()) {
        state = (_i->second).getString();
    }
    if ((_i = _map.find("numVcpus")) != _map.end()) {
        numVcpus = _i->second;
    }
    if ((_i = _map.find("active")) != _map.end()) {
        active = (_i->second).getString();
    }

}

void Domain::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "create") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_CREATE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "destroy") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "undefine") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_UNDEFINE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "suspend") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SUSPEND, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "resume") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_RESUME, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "save") {
        ArgsDomainSave ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("filename")) != inMap.end()) {
            ioArgs.i_filename = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_SAVE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "restore") {
        ArgsDomainRestore ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("filename")) != inMap.end()) {
            ioArgs.i_filename = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_RESTORE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "shutdown") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SHUTDOWN, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "reboot") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REBOOT, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "getXMLDesc") {
        ArgsDomainGetXMLDesc ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["description"] = ::qpid::types::Variant(ioArgs.o_description);
        return;
    }

    if (methodName == "migrate") {
        ArgsDomainMigrate ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("destinationUri")) != inMap.end()) {
            ioArgs.i_destinationUri = (_i->second).getString();
        }
        if ((_i = inMap.find("flags")) != inMap.end()) {
            ioArgs.i_flags = _i->second;
        }
        if ((_i = inMap.find("newDomainName")) != inMap.end()) {
            ioArgs.i_newDomainName = (_i->second).getString();
        }
        if ((_i = inMap.find("uri")) != inMap.end()) {
            ioArgs.i_uri = (_i->second).getString();
        }
        if ((_i = inMap.find("bandwidth")) != inMap.end()) {
            ioArgs.i_bandwidth = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_MIGRATE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
