
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Node.h"
#include "ArgsNodeDomainDefineXML.h"
#include "ArgsNodeStoragePoolDefineXML.h"
#include "ArgsNodeFindStoragePoolSources.h"
#include "ArgsNodeStoragePoolCreateXML.h"

#include <iostream>
#include <sstream>
#include <string.h>

using namespace qmf::com::redhat::libvirt;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Node::packageName  = string ("com.redhat.libvirt");
string  Node::className    = string ("node");
uint8_t Node::md5Sum[MD5_LEN]   =
    {0x89,0x12,0x65,0xa,0x19,0x74,0xfd,0x63,0xbd,0x75,0xce,0x7b,0x4a,0x89,0x9,0x4};

Node::Node (ManagementAgent*, Manageable* _core, const std::string& _hostname, const std::string& _uri, const std::string& _libvirtVersion, const std::string& _apiVersion, const std::string& _hypervisorVersion, const std::string& _hypervisorType, const std::string& _model, uint64_t _memory, uint32_t _cpus, uint32_t _mhz, uint32_t _nodes, uint32_t _sockets, uint32_t _cores, uint32_t _threads) :
    ManagementObject(_core),hostname(_hostname),uri(_uri),libvirtVersion(_libvirtVersion),apiVersion(_apiVersion),hypervisorVersion(_hypervisorVersion),hypervisorType(_hypervisorType),model(_model),memory(_memory),cpus(_cpus),mhz(_mhz),nodes(_nodes),sockets(_sockets),cores(_cores),threads(_threads)
{
    



}

Node::~Node ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Node::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Node::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (14); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (4); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "uri";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "URI of libvirt";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "libvirtVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Version of libvirt on the managed node";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "apiVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Version of libvirt API on the managed node";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "hypervisorVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hypervisor Version";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "hypervisorType";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hypervisor type";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "model";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "CPU Model";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memory";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host memory";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpus";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of CPUS";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "mhz";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "MHz of CPUs";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "nodes";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of NUMA cells.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sockets";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of CPU Sockets per node";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cores";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of cores per socket";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "threads";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Number of threads per core";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "domainDefineXML";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Define a new domain, but does not start it.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xmlDesc";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "XML domain description";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "domain";
    ft[TYPE] = TYPE_REF;
    ft[DIR] = "O";
    ft[DESC] = "Newly created domain object";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "storagePoolDefineXML";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Define a new inactive storage pool based on its XML description. The pool is persistent, until explicitly undefined.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xmlDesc";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "XML Description of the storage pool";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "pool";
    ft[TYPE] = TYPE_REF;
    ft[DIR] = "O";
    ft[DESC] = "Newly created storage pool";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "findStoragePoolSources";
    ft[ARGCOUNT] = 3;
    ft[DESC] = "Talks to a storage backend and attempts to auto-discover the set of available storage pool sources.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "Type of storage pool sources to discover.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "srcSpec";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "XML document specifying discovery source";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xmlDesc";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    ft[DESC] = "XML document consisting of a SourceList element containing a source document appropriate to the given pool type for each discovered source.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "storagePoolCreateXML";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Create a new storage based on its XML description. The pool is not persistent, so its definition will disappear when it is destroyed, or if the host is restarted";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xmlDesc";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "XML Description of the storage pool";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "pool";
    ft[TYPE] = TYPE_REF;
    ft[DIR] = "O";
    ft[DESC] = "Newly created storage pool";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




uint32_t Node::writePropertiesSize() const
{
    uint32_t size = writeTimestampsSize();

    size += (1 + hostname.length());  // hostname
    size += (1 + uri.length());  // uri
    size += (1 + libvirtVersion.length());  // libvirtVersion
    size += (1 + apiVersion.length());  // apiVersion
    size += (1 + hypervisorVersion.length());  // hypervisorVersion
    size += (1 + hypervisorType.length());  // hypervisorType
    size += (1 + model.length());  // model
    size += 8;  // memory
    size += 4;  // cpus
    size += 4;  // mhz
    size += 4;  // nodes
    size += 4;  // sockets
    size += 4;  // cores
    size += 4;  // threads

    return size;
}

void Node::readProperties (const std::string& _sBuf)
{
    char *_tmpBuf = new char[_sBuf.length()];
    memcpy(_tmpBuf, _sBuf.data(), _sBuf.length());
    ::qpid::management::Buffer buf(_tmpBuf, _sBuf.length());
    Mutex::ScopedLock mutex(accessLock);

    {
        std::string _tbuf;
        buf.getRawData(_tbuf, writeTimestampsSize());
        readTimestamps(_tbuf);
    }


    buf.getShortString(hostname);
    buf.getShortString(uri);
    buf.getShortString(libvirtVersion);
    buf.getShortString(apiVersion);
    buf.getShortString(hypervisorVersion);
    buf.getShortString(hypervisorType);
    buf.getShortString(model);
    memory = buf.getLongLong();
    cpus = buf.getLong();
    mhz = buf.getLong();
    nodes = buf.getLong();
    sockets = buf.getLong();
    cores = buf.getLong();
    threads = buf.getLong();


    delete [] _tmpBuf;
}

void Node::writeProperties (std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    {
        std::string _tbuf;
        writeTimestamps(_tbuf);
        buf.putRawData(_tbuf);
    }



    buf.putShortString(hostname);
    buf.putShortString(uri);
    buf.putShortString(libvirtVersion);
    buf.putShortString(apiVersion);
    buf.putShortString(hypervisorVersion);
    buf.putShortString(hypervisorType);
    buf.putShortString(model);
    buf.putLongLong(memory);
    buf.putLong(cpus);
    buf.putLong(mhz);
    buf.putLong(nodes);
    buf.putLong(sockets);
    buf.putLong(cores);
    buf.putLong(threads);


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Node::writeStatistics (std::string& _sBuf, bool skipHeaders)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders) {
        std::string _tbuf;
        writeTimestamps (_tbuf);
        buf.putRawData(_tbuf);
    }



    // Maintenance of hi-lo statistics



    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Node::doMethod (string& methodName, const string& inStr, string& outStr)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;

    bool _matched = false;

    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer outBuf(_msgChars, _bufSize);


    char *_tmpBuf = new char[inStr.length()];
    memcpy(_tmpBuf, inStr.data(), inStr.length());
    ::qpid::management::Buffer inBuf(_tmpBuf, inStr.length());

    if (methodName == "domainDefineXML") {
        _matched = true;
        ArgsNodeDomainDefineXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_DOMAINDEFINEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        {std::string _s; ioArgs.o_domain.encode(_s); outBuf.putRawData(_s);};
    }

    if (methodName == "storagePoolDefineXML") {
        _matched = true;
        ArgsNodeStoragePoolDefineXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLDEFINEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        {std::string _s; ioArgs.o_pool.encode(_s); outBuf.putRawData(_s);};
    }

    if (methodName == "findStoragePoolSources") {
        _matched = true;
        ArgsNodeFindStoragePoolSources ioArgs;
        inBuf.getMediumString(ioArgs.i_type);
        inBuf.getMediumString(ioArgs.i_srcSpec);
        status = coreObject->ManagementMethod (METHOD_FINDSTORAGEPOOLSOURCES, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_xmlDesc);
    }

    if (methodName == "storagePoolCreateXML") {
        _matched = true;
        ArgsNodeStoragePoolCreateXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLCREATEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        {std::string _s; ioArgs.o_pool.encode(_s); outBuf.putRawData(_s);};
    }

    delete [] _tmpBuf;


    if (!_matched) {
        outBuf.putLong(status);
        outBuf.putShortString(Manageable::StatusText(status, text));
    }

    uint32_t _bufLen = outBuf.getPosition();
    outBuf.reset();

    outBuf.getRawData(outStr, _bufLen);
}

std::string Node::getKey() const
{
    std::stringstream key;

    key << hostname;
    return key.str();
}



void Node::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["hostname"] = ::qpid::types::Variant(hostname);
    _map["uri"] = ::qpid::types::Variant(uri);
    _map["libvirtVersion"] = ::qpid::types::Variant(libvirtVersion);
    _map["apiVersion"] = ::qpid::types::Variant(apiVersion);
    _map["hypervisorVersion"] = ::qpid::types::Variant(hypervisorVersion);
    _map["hypervisorType"] = ::qpid::types::Variant(hypervisorType);
    _map["model"] = ::qpid::types::Variant(model);
    _map["memory"] = ::qpid::types::Variant(memory);
    _map["cpus"] = ::qpid::types::Variant(cpus);
    _map["mhz"] = ::qpid::types::Variant(mhz);
    _map["nodes"] = ::qpid::types::Variant(nodes);
    _map["sockets"] = ::qpid::types::Variant(sockets);
    _map["cores"] = ::qpid::types::Variant(cores);
    _map["threads"] = ::qpid::types::Variant(threads);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Node::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }
    if ((_i = _map.find("uri")) != _map.end()) {
        uri = (_i->second).getString();
    }
    if ((_i = _map.find("libvirtVersion")) != _map.end()) {
        libvirtVersion = (_i->second).getString();
    }
    if ((_i = _map.find("apiVersion")) != _map.end()) {
        apiVersion = (_i->second).getString();
    }
    if ((_i = _map.find("hypervisorVersion")) != _map.end()) {
        hypervisorVersion = (_i->second).getString();
    }
    if ((_i = _map.find("hypervisorType")) != _map.end()) {
        hypervisorType = (_i->second).getString();
    }
    if ((_i = _map.find("model")) != _map.end()) {
        model = (_i->second).getString();
    }
    if ((_i = _map.find("memory")) != _map.end()) {
        memory = _i->second;
    }
    if ((_i = _map.find("cpus")) != _map.end()) {
        cpus = _i->second;
    }
    if ((_i = _map.find("mhz")) != _map.end()) {
        mhz = _i->second;
    }
    if ((_i = _map.find("nodes")) != _map.end()) {
        nodes = _i->second;
    }
    if ((_i = _map.find("sockets")) != _map.end()) {
        sockets = _i->second;
    }
    if ((_i = _map.find("cores")) != _map.end()) {
        cores = _i->second;
    }
    if ((_i = _map.find("threads")) != _map.end()) {
        threads = _i->second;
    }

}

void Node::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "domainDefineXML") {
        ArgsNodeDomainDefineXML ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("xmlDesc")) != inMap.end()) {
            ioArgs.i_xmlDesc = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_DOMAINDEFINEXML, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["domain"] = ::qpid::types::Variant(ioArgs.o_domain);
        return;
    }

    if (methodName == "storagePoolDefineXML") {
        ArgsNodeStoragePoolDefineXML ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("xmlDesc")) != inMap.end()) {
            ioArgs.i_xmlDesc = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLDEFINEXML, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["pool"] = ::qpid::types::Variant(ioArgs.o_pool);
        return;
    }

    if (methodName == "findStoragePoolSources") {
        ArgsNodeFindStoragePoolSources ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.i_type = (_i->second).getString();
        }
        if ((_i = inMap.find("srcSpec")) != inMap.end()) {
            ioArgs.i_srcSpec = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_FINDSTORAGEPOOLSOURCES, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["xmlDesc"] = ::qpid::types::Variant(ioArgs.o_xmlDesc);
        return;
    }

    if (methodName == "storagePoolCreateXML") {
        ArgsNodeStoragePoolCreateXML ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("xmlDesc")) != inMap.end()) {
            ioArgs.i_xmlDesc = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLCREATEXML, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["pool"] = ::qpid::types::Variant(ioArgs.o_pool);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
