
#ifndef _MANAGEMENT_NODE_
#define _MANAGEMENT_NODE_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace libvirt {


class Node : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    std::string hostname;
    std::string uri;
    std::string libvirtVersion;
    std::string apiVersion;
    std::string hypervisorVersion;
    std::string hypervisorType;
    std::string model;
    uint64_t memory;
    uint32_t cpus;
    uint32_t mhz;
    uint32_t nodes;
    uint32_t sockets;
    uint32_t cores;
    uint32_t threads;

    // Statistics


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap);
    std::string getKey() const;

    uint32_t writePropertiesSize() const;
    void readProperties(const std::string& buf);
    void writeProperties(std::string& buf) const;
    void writeStatistics(std::string& buf, bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  const std::string& inBuf,
                  std::string& outBuf);


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }


    Node(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, const std::string& _hostname, const std::string& _uri, const std::string& _libvirtVersion, const std::string& _apiVersion, const std::string& _hypervisorVersion, const std::string& _hypervisorType, const std::string& _model, uint64_t _memory, uint32_t _cpus, uint32_t _mhz, uint32_t _nodes, uint32_t _sockets, uint32_t _cores, uint32_t _threads);
    ~Node();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_DOMAINDEFINEXML = 1;
    static const uint32_t METHOD_STORAGEPOOLDEFINEXML = 2;
    static const uint32_t METHOD_FINDSTORAGEPOOLSOURCES = 3;
    static const uint32_t METHOD_STORAGEPOOLCREATEXML = 4;

    // Accessor Methods

};

}}}}

#endif  /*!_MANAGEMENT_NODE_*/
