
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Pool.h"
#include "ArgsPoolGetXMLDesc.h"
#include "ArgsPoolCreateVolumeXML.h"

#include <iostream>
#include <sstream>
#include <string.h>

using namespace qmf::com::redhat::libvirt;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Pool::packageName  = string ("com.redhat.libvirt");
string  Pool::className    = string ("pool");
uint8_t Pool::md5Sum[MD5_LEN]   =
    {0x95,0x86,0x9b,0x6e,0xee,0x6f,0x97,0x79,0x50,0x6d,0x41,0xce,0xfe,0x65,0xf6,0x6e};

Pool::Pool (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent, const std::string& _uuid, const std::string& _name, const std::string& _parentVolume) :
    ManagementObject(_core),uuid(_uuid),name(_name),parentVolume(_parentVolume)
{
    node = _parent->GetManagementObject ()->getObjectId ();
    state = "";
    capacity = 0;
    allocation = 0;
    available = 0;



}

Pool::~Pool ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Pool::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Pool::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (8); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (8); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "uuid";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Pool UUID";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Pool name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "parentVolume";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "If this pool is an LVM pool, this will contain the parent volume path.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "state";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Pool state";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "capacity";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Pool size in bytes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "allocation";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Current allocation in bytes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "available";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Available space in bytes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "node";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Node of this storage pool";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "getXMLDesc";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Return an XML description of the storage pool.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "description";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    ft[DESC] = "XML description of the storage pool.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "create";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Starts an inactive storage pool.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "build";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Build the underlying storage pool.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "destroy";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Destroy an active storage pool. This will deactivate the pool on the host, but keep any persistent config associated with it. If it has a persistent config it can later be restarted with a create() call";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "delete";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Destroy the pool and delete its definition";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "undefine";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Undefine an inactive storage pool.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "createVolumeXML";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Create a storage volume within a pool based on an XML description.  Not all pool types support volume creation.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xmlDesc";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    ft[DESC] = "XML Description of the volume to create";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "volume";
    ft[TYPE] = TYPE_REF;
    ft[DIR] = "O";
    ft[DESC] = "Newly created volume";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "refresh";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Request that the pool refresh its list of volumes.";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




uint32_t Pool::writePropertiesSize() const
{
    uint32_t size = writeTimestampsSize();

    size += (1 + uuid.length());  // uuid
    size += (1 + name.length());  // name
    size += (1 + parentVolume.length());  // parentVolume
    size += (1 + state.length());  // state
    size += 8;  // capacity
    size += 8;  // allocation
    size += 8;  // available
    size += 16;  // node

    return size;
}

void Pool::readProperties (const std::string& _sBuf)
{
    char *_tmpBuf = new char[_sBuf.length()];
    memcpy(_tmpBuf, _sBuf.data(), _sBuf.length());
    ::qpid::management::Buffer buf(_tmpBuf, _sBuf.length());
    Mutex::ScopedLock mutex(accessLock);

    {
        std::string _tbuf;
        buf.getRawData(_tbuf, writeTimestampsSize());
        readTimestamps(_tbuf);
    }


    buf.getShortString(uuid);
    buf.getShortString(name);
    buf.getShortString(parentVolume);
    buf.getShortString(state);
    capacity = buf.getLongLong();
    allocation = buf.getLongLong();
    available = buf.getLongLong();
    {std::string _s; buf.getRawData(_s, node.encodedSize()); node.decode(_s);};


    delete [] _tmpBuf;
}

void Pool::writeProperties (std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    {
        std::string _tbuf;
        writeTimestamps(_tbuf);
        buf.putRawData(_tbuf);
    }



    buf.putShortString(uuid);
    buf.putShortString(name);
    buf.putShortString(parentVolume);
    buf.putShortString(state);
    buf.putLongLong(capacity);
    buf.putLongLong(allocation);
    buf.putLongLong(available);
    {std::string _s; node.encode(_s); buf.putRawData(_s);};


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Pool::writeStatistics (std::string& _sBuf, bool skipHeaders)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders) {
        std::string _tbuf;
        writeTimestamps (_tbuf);
        buf.putRawData(_tbuf);
    }



    // Maintenance of hi-lo statistics



    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Pool::doMethod (string& methodName, const string& inStr, string& outStr)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;

    bool _matched = false;

    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer outBuf(_msgChars, _bufSize);


    char *_tmpBuf = new char[inStr.length()];
    memcpy(_tmpBuf, inStr.data(), inStr.length());
    ::qpid::management::Buffer inBuf(_tmpBuf, inStr.length());

    if (methodName == "getXMLDesc") {
        _matched = true;
        ArgsPoolGetXMLDesc ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_description);
    }

    if (methodName == "create") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_CREATE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "build") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_BUILD, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "destroy") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "delete") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DELETE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "undefine") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_UNDEFINE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    if (methodName == "createVolumeXML") {
        _matched = true;
        ArgsPoolCreateVolumeXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_CREATEVOLUMEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        {std::string _s; ioArgs.o_volume.encode(_s); outBuf.putRawData(_s);};
    }

    if (methodName == "refresh") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REFRESH, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }

    delete [] _tmpBuf;


    if (!_matched) {
        outBuf.putLong(status);
        outBuf.putShortString(Manageable::StatusText(status, text));
    }

    uint32_t _bufLen = outBuf.getPosition();
    outBuf.reset();

    outBuf.getRawData(outStr, _bufLen);
}

std::string Pool::getKey() const
{
    std::stringstream key;

    key << uuid << ",";
    key << name;
    return key.str();
}



void Pool::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["uuid"] = ::qpid::types::Variant(uuid);
    _map["name"] = ::qpid::types::Variant(name);
    _map["parentVolume"] = ::qpid::types::Variant(parentVolume);
    _map["state"] = ::qpid::types::Variant(state);
    _map["capacity"] = ::qpid::types::Variant(capacity);
    _map["allocation"] = ::qpid::types::Variant(allocation);
    _map["available"] = ::qpid::types::Variant(available);
    _map["node"] = ::qpid::types::Variant(node);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Pool::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("uuid")) != _map.end()) {
        uuid = (_i->second).getString();
    }
    if ((_i = _map.find("name")) != _map.end()) {
        name = (_i->second).getString();
    }
    if ((_i = _map.find("parentVolume")) != _map.end()) {
        parentVolume = (_i->second).getString();
    }
    if ((_i = _map.find("state")) != _map.end()) {
        state = (_i->second).getString();
    }
    if ((_i = _map.find("capacity")) != _map.end()) {
        capacity = _i->second;
    }
    if ((_i = _map.find("allocation")) != _map.end()) {
        allocation = _i->second;
    }
    if ((_i = _map.find("available")) != _map.end()) {
        available = _i->second;
    }
    if ((_i = _map.find("node")) != _map.end()) {
        node = _i->second;
    }

}

void Pool::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "getXMLDesc") {
        ArgsPoolGetXMLDesc ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["description"] = ::qpid::types::Variant(ioArgs.o_description);
        return;
    }

    if (methodName == "create") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_CREATE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "build") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_BUILD, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "destroy") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "delete") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DELETE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "undefine") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_UNDEFINE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "createVolumeXML") {
        ArgsPoolCreateVolumeXML ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("xmlDesc")) != inMap.end()) {
            ioArgs.i_xmlDesc = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_CREATEVOLUMEXML, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["volume"] = ::qpid::types::Variant(ioArgs.o_volume);
        return;
    }

    if (methodName == "refresh") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REFRESH, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
