
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Volume.h"
#include "ArgsVolumeGetXMLDesc.h"

#include <iostream>
#include <sstream>
#include <string.h>

using namespace qmf::com::redhat::libvirt;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Volume::packageName  = string ("com.redhat.libvirt");
string  Volume::className    = string ("volume");
uint8_t Volume::md5Sum[MD5_LEN]   =
    {0x96,0x58,0x29,0x6f,0x9d,0xe3,0xd3,0x82,0xc1,0x16,0xbb,0x62,0x7f,0x19,0x28,0xe};

Volume::Volume (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent, const std::string& _key, const std::string& _path, const std::string& _name, const std::string& _childLVMName) :
    ManagementObject(_core),key(_key),path(_path),name(_name),childLVMName(_childLVMName)
{
    storagePool = _parent->GetManagementObject ()->getObjectId ();
    capacity = 0;
    allocation = 0;



}

Volume::~Volume ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Volume::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Volume::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (2); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "key";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Storage volume key";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "path";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Storage volume path";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Storage volume name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "childLVMName";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The name of the LVM pool associated with this volume, or blank of non-existant.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "capacity";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Capacity of storage volume in bytes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "allocation";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Current allocation in bytes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "storagePool";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Pool where this storage volume exists";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "getXMLDesc";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Return an XML description of the volume.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "description";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    ft[DESC] = "XML description of the volume.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "delete";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Delete the storage volume from the pool.";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




uint32_t Volume::writePropertiesSize() const
{
    uint32_t size = writeTimestampsSize();

    size += (1 + key.length());  // key
    size += (1 + path.length());  // path
    size += (1 + name.length());  // name
    size += (1 + childLVMName.length());  // childLVMName
    size += 8;  // capacity
    size += 8;  // allocation
    size += 16;  // storagePool

    return size;
}

void Volume::readProperties (const std::string& _sBuf)
{
    char *_tmpBuf = new char[_sBuf.length()];
    memcpy(_tmpBuf, _sBuf.data(), _sBuf.length());
    ::qpid::management::Buffer buf(_tmpBuf, _sBuf.length());
    Mutex::ScopedLock mutex(accessLock);

    {
        std::string _tbuf;
        buf.getRawData(_tbuf, writeTimestampsSize());
        readTimestamps(_tbuf);
    }


    buf.getShortString(key);
    buf.getShortString(path);
    buf.getShortString(name);
    buf.getShortString(childLVMName);
    capacity = buf.getLongLong();
    allocation = buf.getLongLong();
    {std::string _s; buf.getRawData(_s, storagePool.encodedSize()); storagePool.decode(_s);};


    delete [] _tmpBuf;
}

void Volume::writeProperties (std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    {
        std::string _tbuf;
        writeTimestamps(_tbuf);
        buf.putRawData(_tbuf);
    }



    buf.putShortString(key);
    buf.putShortString(path);
    buf.putShortString(name);
    buf.putShortString(childLVMName);
    buf.putLongLong(capacity);
    buf.putLongLong(allocation);
    {std::string _s; storagePool.encode(_s); buf.putRawData(_s);};


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Volume::writeStatistics (std::string& _sBuf, bool skipHeaders)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders) {
        std::string _tbuf;
        writeTimestamps (_tbuf);
        buf.putRawData(_tbuf);
    }



    // Maintenance of hi-lo statistics



    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void Volume::doMethod (string& methodName, const string&, string& outStr)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;

    bool _matched = false;

    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer outBuf(_msgChars, _bufSize);


    if (methodName == "getXMLDesc") {
        _matched = true;
        ArgsVolumeGetXMLDesc ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_description);
    }

    if (methodName == "delete") {
        _matched = true;
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DELETE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
    }


    if (!_matched) {
        outBuf.putLong(status);
        outBuf.putShortString(Manageable::StatusText(status, text));
    }

    uint32_t _bufLen = outBuf.getPosition();
    outBuf.reset();

    outBuf.getRawData(outStr, _bufLen);
}

std::string Volume::getKey() const
{
    std::stringstream key;

    key << key << ",";
    key << path << ",";
    key << name;
    return key.str();
}



void Volume::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["key"] = ::qpid::types::Variant(key);
    _map["path"] = ::qpid::types::Variant(path);
    _map["name"] = ::qpid::types::Variant(name);
    _map["childLVMName"] = ::qpid::types::Variant(childLVMName);
    _map["capacity"] = ::qpid::types::Variant(capacity);
    _map["allocation"] = ::qpid::types::Variant(allocation);
    _map["storagePool"] = ::qpid::types::Variant(storagePool);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Volume::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("key")) != _map.end()) {
        key = (_i->second).getString();
    }
    if ((_i = _map.find("path")) != _map.end()) {
        path = (_i->second).getString();
    }
    if ((_i = _map.find("name")) != _map.end()) {
        name = (_i->second).getString();
    }
    if ((_i = _map.find("childLVMName")) != _map.end()) {
        childLVMName = (_i->second).getString();
    }
    if ((_i = _map.find("capacity")) != _map.end()) {
        capacity = _i->second;
    }
    if ((_i = _map.find("allocation")) != _map.end()) {
        allocation = _i->second;
    }
    if ((_i = _map.find("storagePool")) != _map.end()) {
        storagePool = _i->second;
    }

}

void Volume::doMethod (string& methodName, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "getXMLDesc") {
        ArgsVolumeGetXMLDesc ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["description"] = ::qpid::types::Variant(ioArgs.o_description);
        return;
    }

    if (methodName == "delete") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DELETE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
